// Bar1dVC6TestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Bar1dVC6Test.h"
#include "Bar1dVC6TestDlg.h"
#include "../../1dbarEncodeDll.h"

extern BOOL SaveBitmapToFile(HBITMAP hBitmap , LPCTSTR lpFileName) ;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

HBITMAP hbmp = NULL;
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBar1dVC6TestDlg dialog

CBar1dVC6TestDlg::CBar1dVC6TestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBar1dVC6TestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBar1dVC6TestDlg)
	m_strPrefix = _T("");
	m_nRotateAngle = 0;
	m_strSurfix = _T("");
	m_strText = _T("12345");
	m_strFontName = _T("");
	m_nFontSize = 0;
	m_nMargin = 10;
	m_nWhiteSpace = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBar1dVC6TestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBar1dVC6TestDlg)
	DDX_Control(pDX, IDC_BACKCOLOR, m_BackColor);
	DDX_Control(pDX, IDC_FORECOLOR, m_ForeColor);
	DDX_Control(pDX, IDC_VCENTER, m_VCenter);
	DDX_Control(pDX, IDC_TOP, m_Top);
	DDX_Control(pDX, IDC_SYMBOLOGY, m_Symbology);
	DDX_Control(pDX, IDC_RIGHT, m_Right);
	DDX_Control(pDX, IDC_LEFT, m_Left);
	DDX_Control(pDX, IDC_HCENTER, m_HCenter);
	DDX_Control(pDX, IDC_BOTTOM, m_Bottom);
	DDX_Text(pDX, IDC_PREFIX, m_strPrefix);
	DDX_Text(pDX, IDC_ROTATION_ANGLE, m_nRotateAngle);
	DDX_Text(pDX, IDC_SUFFIX, m_strSurfix);
	DDX_Text(pDX, IDC_TEXT, m_strText);
	DDX_Text(pDX, IDC_FONTNAME, m_strFontName);
	DDX_Text(pDX, IDC_FONTSIZE, m_nFontSize);
	DDX_Text(pDX, IDC_MARGIN, m_nMargin);
	DDX_Text(pDX, IDC_WHITESPACE, m_nWhiteSpace);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBar1dVC6TestDlg, CDialog)
	//{{AFX_MSG_MAP(CBar1dVC6TestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SELECTFONT, OnSelectfont)
	ON_BN_CLICKED(IDENCODE, OnEncode)
	ON_BN_CLICKED(IDSAVE, OnSave)
	ON_BN_CLICKED(IDBUY, OnBuy)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBar1dVC6TestDlg message handlers

BOOL CBar1dVC6TestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
    m_BackColor.SetColor(RGB(255,255,255));
    m_ForeColor.SetColor(RGB(0,0,0));
	SetDropDownSize(m_Symbology, 10);
	FillSymbology();
	m_Symbology.SetCurSel(0);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBar1dVC6TestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}


void CBar1dVC6TestDlg::OnPaint() 
{
	CBitmap m_OffscreenBitmap, *m_pOldBitmap;

	CPaintDC dc(this); // device context for painting
	if (IsIconic())
	{

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
	dc.TextOut(100,150,"Trial version will replace some elements of input ing with '8' randomly");
    if (hbmp)
	{
		CDC m_dcOffscreen;

		m_dcOffscreen.CreateCompatibleDC(&dc);
		m_OffscreenBitmap.Attach(hbmp);
		m_pOldBitmap = m_dcOffscreen.SelectObject(&m_OffscreenBitmap);
		dc.BitBlt(10, 10, 300, 300,&m_dcOffscreen, 0, 0, SRCCOPY);
		m_pOldBitmap = m_dcOffscreen.SelectObject(m_pOldBitmap);
		m_OffscreenBitmap.Detach();
		ReleaseDC(&m_dcOffscreen);
	}
 
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBar1dVC6TestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CBar1dVC6TestDlg::SetDropDownSize(CComboBox &box, UINT LinesToDisplay)
{
    ASSERT(IsWindow(box));	// Window must exist or SetWindowPos won't work

    CRect cbSize;			// current size of combo box
    int Height;				// new height for drop-down portion of combo box

    box.GetClientRect(cbSize);
    Height = box.GetItemHeight(-1);      // start with size of the edit-box portion
    Height += box.GetItemHeight(0) * LinesToDisplay;	// add height of lines of text

    // Note: The use of SM_CYEDGE assumes that we're using Windows '95
    // Now add on the height of the border of the edit box
    Height += GetSystemMetrics(SM_CYEDGE) * 2; // top & bottom edges

    // The height of the border of the drop-down box
    Height += GetSystemMetrics(SM_CYEDGE) * 2; // top & bottom edges

    // now set the size of the window
    box.SetWindowPos(NULL,            // not relative to any other windows
        0, 0,                         // TopLeft corner doesn't change
        cbSize.right, Height,         // existing width, new height
        SWP_NOMOVE | SWP_NOZORDER     // don't move box or change z-ordering.
        );
}

void CBar1dVC6TestDlg::FillSymbology()
{
	m_Symbology.AddString("BARCODE_CODE11");
	m_Symbology.AddString("BARCODE_C25MATRIX");
	m_Symbology.AddString("BARCODE_C25INTER");
	m_Symbology.AddString("BARCODE_C25IATA");
	m_Symbology.AddString("BARCODE_C25LOGIC");
	m_Symbology.AddString("BARCODE_C25IND");
	m_Symbology.AddString("BARCODE_CODE39");
	m_Symbology.AddString("BARCODE_EXCODE39");
	m_Symbology.AddString("BARCODE_EANX");
	m_Symbology.AddString("BARCODE_EAN128");
	m_Symbology.AddString("BARCODE_CODABAR");
	m_Symbology.AddString("BARCODE_CODE128");
	m_Symbology.AddString("BARCODE_DPLEIT");
	m_Symbology.AddString("BARCODE_DPIDENT");
	m_Symbology.AddString("BARCODE_CODE16K");
	m_Symbology.AddString("BARCODE_CODE93");
	m_Symbology.AddString("BARCODE_FLAT");
	m_Symbology.AddString("BARCODE_TELEPEN");
	m_Symbology.AddString("BARCODE_UPCA");
	m_Symbology.AddString("BARCODE_UPCE");
	m_Symbology.AddString("BARCODE_POSTNET");
	m_Symbology.AddString("BARCODE_MSI_PLESSEY");
	m_Symbology.AddString("BARCODE_FIM");
	m_Symbology.AddString("BARCODE_LOGMARS");
	m_Symbology.AddString("BARCODE_PHARMA");
	m_Symbology.AddString("BARCODE_PZN");
	m_Symbology.AddString("BARCODE_PHARMA_TWO");
	m_Symbology.AddString("BARCODE_CODE128B");
	m_Symbology.AddString("BARCODE_AUSPOST");
	m_Symbology.AddString("BARCODE_AUSREPLY");
	m_Symbology.AddString("BARCODE_AUSROUTE");
	m_Symbology.AddString("BARCODE_AUSREDIRECT");
	m_Symbology.AddString("BARCODE_ISBNX");
	m_Symbology.AddString("BARCODE_RM4SCC");
	m_Symbology.AddString("BARCODE_ITF14");
	m_Symbology.AddString("BARCODE_NVE18");
//	m_Symbology.AddString("BARCODE_KOREAPOST");
	m_Symbology.AddString("BARCODE_PLANET");
	m_Symbology.AddString("BARCODE_ONECODE");
	m_Symbology.AddString("BARCODE_PLESSEY");
	m_Symbology.AddString("BARCODE_TELEPEN_NUM");
	m_Symbology.AddString("BARCODE_MSI_10");
	m_Symbology.AddString("BARCODE_MSI_10_10");
	m_Symbology.AddString("BARCODE_MSI_11");
	m_Symbology.AddString("BARCODE_MSI_11_10");
	m_Symbology.AddString("BARCODE_CODE39_43");
	m_Symbology.AddString("BARCODE_EXCODE39_43");
}


int CBar1dVC6TestDlg::GetSymbology()
{
    CString strSym ;
	GetDlgItemText(IDC_SYMBOLOGY,strSym);
	if (strSym == "BARCODE_CODE11") return 1;
	if (strSym == "BARCODE_C25MATRIX") return 2;
	if (strSym == "BARCODE_C25INTER") return 3;
	if (strSym == "BARCODE_C25IATA") return 4;
	if (strSym == "BARCODE_C25LOGIC") return 6;
	if (strSym == "BARCODE_C25IND") return 7;
	if (strSym == "BARCODE_CODE39") return 8;
	if (strSym == "BARCODE_EXCODE39") return 9;
	if (strSym == "BARCODE_EANX") return 13;
	if (strSym == "BARCODE_EAN128") return 16;
	if (strSym == "BARCODE_CODABAR") return 18;
	if (strSym == "BARCODE_CODE128") return 20;
	if (strSym == "BARCODE_DPLEIT") return 21;
	if (strSym == "BARCODE_DPIDENT") return 22;
	if (strSym == "BARCODE_CODE16K") return 23;
	if (strSym == "BARCODE_CODE93") return 25;
	if (strSym == "BARCODE_FLAT") return 28;
	if (strSym == "BARCODE_TELEPEN") return 32;
	if (strSym == "BARCODE_UPCA") return 34;
	if (strSym == "BARCODE_UPCE") return 37;
	if (strSym == "BARCODE_POSTNET") return 40;
	if (strSym == "BARCODE_MSI_PLESSEY") return 47;
	if (strSym == "BARCODE_FIM") return 49;
	if (strSym == "BARCODE_LOGMARS") return 50;
	if (strSym == "BARCODE_PHARMA") return 51;
	if (strSym == "BARCODE_PZN") return 52;
	if (strSym == "BARCODE_PHARMA_TWO")return 53;
	if (strSym == "BARCODE_CODE128B") return 60;
	if (strSym == "BARCODE_AUSPOST") return 63;
	if (strSym == "BARCODE_AUSREPLY") return 66;
	if (strSym == "BARCODE_AUSROUTE") return 67;
	if (strSym == "BARCODE_AUSREDIRECT") return 68;
	if (strSym == "BARCODE_ISBNX") return 69;
	if (strSym == "BARCODE_RM4SCC") return 70;
	if (strSym == "BARCODE_ITF14") return 72;
	if (strSym == "BARCODE_NVE18") return 75;
//	if (strSym == "BARCODE_KOREAPOST") return 77;
	if (strSym == "BARCODE_PLANET") return 82;
	if (strSym == "BARCODE_ONECODE") return 85;
	if (strSym == "BARCODE_PLESSEY") return 86;
	if (strSym == "BARCODE_TELEPEN_NUM") return 100;
	if (strSym == "BARCODE_MSI_10") return 101;
	if (strSym == "BARCODE_MSI_10_10") return 102;
	if (strSym == "BARCODE_MSI_11") return 103;
	if (strSym == "BARCODE_MSI_11_10") return 104;
	if (strSym == "BARCODE_CODE39_43") return 105;
	if (strSym == "BARCODE_EXCODE39_43") return 106;
	return 0;
}

void CBar1dVC6TestDlg::OnSelectfont() 
{
	CFontDialog dlgFont;
	if (dlgFont.DoModal() == IDOK)
	{
		m_strFontName = dlgFont.GetFaceName();
		m_nFontSize = dlgFont.GetSize() / 10;
		UpdateData(FALSE);
	}	
}


void CBar1dVC6TestDlg::OnEncode() 
{

    SYMBOL tSymbol;
   UpdateData();
   InitWorkSpace(&tSymbol);
   tSymbol.symbology = GetSymbology();
   tSymbol.foreColor = m_ForeColor.GetColor();
   tSymbol.backColor = m_BackColor.GetColor();
   tSymbol.charSize = m_nFontSize;
   tSymbol.borderWidth = m_nMargin;
   tSymbol.whiteSpaceWidth = m_nWhiteSpace;
   tSymbol.rotateAngle = m_nRotateAngle;

   if (m_strFontName !="") strcpy(tSymbol.charSet, m_strFontName.GetBuffer(0));
   if (m_strPrefix !="") strcpy(tSymbol.prefix, m_strPrefix.GetBuffer(0));
   if (m_strSurfix !="") strcpy(tSymbol.surfix, m_strSurfix.GetBuffer(0));
   if (m_strText !="") strcpy(tSymbol.text, m_strText.GetBuffer(0));
   if (m_Top.GetCheck() == BST_CHECKED)  tSymbol.textAlign |= DT_TOP;
   if (m_Left.GetCheck() == BST_CHECKED)  tSymbol.textAlign |= DT_LEFT;
   if (m_Bottom.GetCheck() == BST_CHECKED)  tSymbol.textAlign |= DT_BOTTOM;
   if (m_Right.GetCheck() == BST_CHECKED)  tSymbol.textAlign |= DT_RIGHT;
   if (m_VCenter.GetCheck() == BST_CHECKED)  tSymbol.textAlign |= DT_VCENTER;
   if (m_HCenter.GetCheck() == BST_CHECKED)  tSymbol.textAlign |= DT_CENTER;

   FreeWorkSpace();
   hbmp = Bar1DEncode2Bitmap(&tSymbol);
   
   if (tSymbol.errtxt[0]) AfxMessageBox(tSymbol.errtxt);
   Invalidate();
}

void CBar1dVC6TestDlg::OnSave() 
{
/*    _SYMBOL tSymbol;
   UpdateData();
   _InitBarcodeContext(&tSymbol);
   tSymbol.symbology = GetSymbology();
   tSymbol.foreColor = m_ForeColor.GetColor();
   tSymbol.backColor = m_BackColor.GetColor();
   tSymbol.charSize = m_nFontSize;
   tSymbol.borderWidth = m_nMargin;
   tSymbol.whiteSpaceWidth = m_nWhiteSpace;
   tSymbol.rotateAngle = m_nRotateAngle;

   if (m_strFontName !="") strcpy(tSymbol.charSet, m_strFontName.GetBuffer(0));
   if (m_strPrefix !="") strcpy(tSymbol.prefix, m_strPrefix.GetBuffer(0));
   if (m_strSurfix !="") strcpy(tSymbol.surfix, m_strSurfix.GetBuffer(0));
   if (m_strText !="") strcpy(tSymbol.text, m_strText.GetBuffer(0));
   if (m_Top.GetCheck() == BST_CHECKED)  tSymbol.textAlign |= DT_TOP;
   if (m_Left.GetCheck() == BST_CHECKED)  tSymbol.textAlign |= DT_LEFT;
   if (m_Bottom.GetCheck() == BST_CHECKED)  tSymbol.textAlign |= DT_BOTTOM;
   if (m_Right.GetCheck() == BST_CHECKED)  tSymbol.textAlign |= DT_RIGHT;
   if (m_VCenter.GetCheck() == BST_CHECKED)  tSymbol.textAlign |= DT_VCENTER;
   if (m_HCenter.GetCheck() == BST_CHECKED)  tSymbol.textAlign |= DT_CENTER;

   _1DBarEncode2File(&tSymbol,"c:\\1dbar.bmp");
   if (tSymbol.errtxt[0]) AfxMessageBox(tSymbol.errtxt);
	_FreeBarcodeContext();*/

	CFileDialog dlgFile(FALSE);
	if (dlgFile.DoModal() == IDOK)
	{
		CString sFile = dlgFile.GetFileName();
		int nPos = sFile.ReverseFind('.');
		CString sExt = sFile.Right(sFile.GetLength() - nPos);
		sExt.MakeUpper();
		if (sExt == ".GIF")
			MessageBox("Only support BMP format","alert",MB_OK);
		else if (sExt == ".PNG")
			MessageBox("Only support BMP format","alert",MB_OK);
		else if (sExt == ".BMP")
			SaveBitmapToFile(hbmp,sFile.GetBuffer(0));
//			xImage.Save(sFile,CXIMAGE_FORMAT_BMP);
		else	//		xImage.Save(sFile,CXIMAGE_FORMAT_BMP);
			SaveBitmapToFile(hbmp,sFile.GetBuffer(0));

	}
}

void CBar1dVC6TestDlg::OnBuy() 
{
   ShellExecute(this->GetSafeHwnd(),"open","http://www.aipsys.com/order.htm",NULL,NULL,SW_SHOW);	
}

BOOL CBar1dVC6TestDlg::SaveBitmapToFile(HBITMAP hBitmap , LPCTSTR lpFileName) 
{

	HDC hDC; 


	int iBits; 


	WORD wBitCount; 

	DWORD dwPaletteSize=0,
	dwBmBitsSize,
	dwDIBSize, dwWritten;


	BITMAP Bitmap; 


	BITMAPFILEHEADER bmfHdr; 


	BITMAPINFOHEADER bi; 


	LPBITMAPINFOHEADER lpbi;


	HANDLE fh, hDib;
	HPALETTE hPal,hOldPal=NULL;


	hDC = CreateDC("DISPLAY",NULL,NULL,NULL);
	iBits = GetDeviceCaps(hDC, BITSPIXEL) * GetDeviceCaps(hDC, PLANES);
	DeleteDC(hDC);

	if (iBits <= 1)
		wBitCount = 1;
	else if (iBits <= 4)
		wBitCount = 4;
	else if (iBits <= 8)
		wBitCount = 8;
	else if (iBits <= 24)
		wBitCount = 24;
	else 
		wBitCount = 32;

	if (wBitCount <= 8)
		dwPaletteSize = (1 << wBitCount) *sizeof(RGBQUAD);


	GetObject(hBitmap, sizeof(BITMAP), (LPSTR)&Bitmap);
	bi.biSize = sizeof(BITMAPINFOHEADER);
	bi.biWidth = Bitmap.bmWidth;
	bi.biHeight = Bitmap.bmHeight;
	bi.biPlanes = 1;
	bi.biBitCount = wBitCount;
	bi.biCompression = BI_RGB;
	bi.biSizeImage = 0;
	bi.biXPelsPerMeter = 0;
	bi.biYPelsPerMeter = 0;
	bi.biClrUsed = 0;
	bi.biClrImportant = 0;

	dwBmBitsSize = ((Bitmap.bmWidth *wBitCount+31)/32)* 4*Bitmap.bmHeight ;


	hDib = GlobalAlloc(GHND,dwBmBitsSize+dwPaletteSize+sizeof(BITMAPINFOHEADER));
	lpbi = (LPBITMAPINFOHEADER)GlobalLock(hDib);
	*lpbi = bi;


	hPal = (HPALETTE)GetStockObject(DEFAULT_PALETTE);
	if (hPal)
	{
		hDC = ::GetDC(NULL);
		hOldPal = SelectPalette(hDC, hPal, FALSE);
		RealizePalette(hDC);
	}


	GetDIBits(hDC, hBitmap, 0, (UINT)Bitmap.bmHeight,(LPSTR)lpbi + sizeof(BITMAPINFOHEADER)+dwPaletteSize,(LPBITMAPINFO)lpbi, DIB_RGB_COLORS);


	if (hOldPal)
	{
		SelectPalette(hDC, hOldPal, TRUE);
		RealizePalette(hDC);
		::ReleaseDC(NULL, hDC);
	}


	fh = CreateFile(lpFileName, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS,
	FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, NULL);

	if (fh == INVALID_HANDLE_VALUE)
		return FALSE;


	bmfHdr.bfType = 0x4D42; // "BM"
	dwDIBSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + dwPaletteSize + dwBmBitsSize; 
	bmfHdr.bfSize = dwDIBSize;
	bmfHdr.bfReserved1 = 0;
	bmfHdr.bfReserved2 = 0;
	bmfHdr.bfOffBits = (DWORD)sizeof(BITMAPFILEHEADER) + (DWORD)sizeof(BITMAPINFOHEADER)+ dwPaletteSize;


	WriteFile(fh, (LPSTR)&bmfHdr, sizeof(BITMAPFILEHEADER), &dwWritten, NULL);


	WriteFile(fh, (LPSTR)lpbi, dwDIBSize, &dwWritten, NULL);


	GlobalUnlock(hDib);
	GlobalFree(hDib);
	CloseHandle(fh);

	return TRUE;
}
