// Bar1dVC6TestDlg.h : header file
//

#if !defined(AFX_BAR1DVC6TESTDLG_H__888C51FA_5BB4_411B_B988_F3A66ED29E6F__INCLUDED_)
#define AFX_BAR1DVC6TESTDLG_H__888C51FA_5BB4_411B_B988_F3A66ED29E6F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "ColorBox.h"


/////////////////////////////////////////////////////////////////////////////
// CBar1dVC6TestDlg dialog

class CBar1dVC6TestDlg : public CDialog
{
// Construction
public:
	CBar1dVC6TestDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CBar1dVC6TestDlg)
	enum { IDD = IDD_BAR1DVC6TEST_DIALOG };
	CColorBox	m_BackColor;
	CColorBox	m_ForeColor;
	CButton	m_VCenter;
	CButton	m_Top;
	CComboBox	m_Symbology;
	CSpinButtonCtrl	m_Spin;
	CButton	m_Right;
	CButton	m_Left;
	CButton	m_HCenter;
	CButton	m_Bottom;
	CString	m_strPrefix;
	int		m_nRotateAngle;
	CString	m_strSurfix;
	CString	m_strText;
	CString	m_strFontName;
	int		m_nFontSize;
	int		m_nMargin;
	int		m_nWhiteSpace;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBar1dVC6TestDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CBar1dVC6TestDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSelectfont();
	afx_msg void OnEncode();
	afx_msg void OnSave();
	afx_msg void OnBuy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	void FillSymbology();
	int GetSymbology();
    void SetDropDownSize(CComboBox &box, UINT LinesToDisplay);
	BOOL SaveBitmapToFile(HBITMAP hBitmap , LPCTSTR lpFileName); 
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BAR1DVC6TESTDLG_H__888C51FA_5BB4_411B_B988_F3A66ED29E6F__INCLUDED_)
